<!DOCTYPE html>
<html lang="es">
  <head>
    <title>Validacion Formulario JS</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/css/bootstrap.min.css" crossorigin="anonymous">

  </head>
<body>
  <div class="row justify-content-center mt-5">
    <div class="col-md-6 border">  
          <h1>Alta de Usuario</h1>
        <form id="registrationForm" action="">
          <div class="form-group row">
            <div class="col-4">
              <label for="provincias">Provincia:</label>
              <select class="form-control" id="provincias">
              </select>
            </div>
          </div>
          <div class="form-group row">
            <div class="col">
                <label for="username">Usuario: </label>
                <input id="username" type="text" class="form-control">
            </div>
          </div>
          <div class="form-group row">
            <div class="col">
                <label for="password">Contraseña: </label>
                <input id="password" type="password" class="form-control">
            </div>
          </div>
          <div class="form-group row">
            <div class="col">
                <label for="confirmPassword">Confirma Contraseña: </label>
                <input id="confirmPassword" type="password" class="form-control">
            </div>
          </div>
          <div class="row">
            <div class="col">
                <button class="btn btn-primary btn-block">
                  Registrarse
              </button>
            </div>
          </div>
        </form>
      </div>
    </div>
<script>
    "use strict"

    const spinner = document.getElementById("provincias")
    var provincias = {
        "01":"ALMERIA",
        "02":"CADIZ",
        "03":"CORDOBA",
        "04":"GRANADA",
        "05":"HUELVA",
        "06":"JAEN",
        "07":"MALAGA",
        "08":"SEVILLA",
    }

    provincias.forEach(valor => {
        let child = spinner.childNode;
        child.innerHTML(`<option value="${valor}" ></option>`)
    })

    const usuario = document.getElementById("username");
    const usuarioValor = usuario.value;

    const contrasena = document.getElementById("password");
    const contrasenaValor = contrasena.value;

    const contrasenaDos = document.getElementById("confirmPassword");
    const contrasenaDosValor = contrasenaDos.value;

    const botonRegistrar = document.getElementsByTagName("button")[0]


    botonRegistrar.addEventListener("click", e => {
        e.preventDefault()
        validarFormulario()
    });


    let validarFormulario = () => {
        let estaVacio = (valor) => (valor === "" || valor == null) ? true : false
        

        let marcarError = (stringError, ...elementos) => {
            /* he intentado que pase un arr de elementos con "...elementos" pero nada, me lo devuelve vacío */
            window.alert(stringError)

            elementos.forEach(elemento => {
                elemento.style.backgroundColor = "#ff0000 !important";
                
                let padreElemento = elemento.parentNode;
                const nuevoDiv = document.createElement("div");
                nuevoDiv.classList.add("text-danger");
                nuevoDiv.append(`${stringError}`);

                padreElemento.append(nuevoDiv);
            });
        }

        if (estaVacio(usuarioValor))       marcarError("No puedes dejar el usuario vacio", usuario);
        if (estaVacio(contrasenaValor))    marcarError("No puedes dejar la contraseña en blanco", contrasena);
        if (estaVacio(contrasenaDosValor)) marcarError("No puedes dejar la confirmación de la contraseña en blanco", contrasenaDos);

        if (contrasenaValor != contrasenaDosValor) marcarError("Las contraseñas no coinciden", contrasena, contrasenaDos);

    }

</script>
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.slim.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/2.6.0/umd/popper.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/js/bootstrap.min.js" crossorigin="anonymous"></script>
  </body>
</html>